# -*- mode: ruby -*-
# vi: set ft=ruby :

# All Vagrant configuration is done below. The "2" in Vagrant.configure
# configures the configuration version (we support older styles for
# backwards compatibility). Please don't change it unless you know what
# you're doing.
Vagrant.configure("2") do |config|
  # The most common configuration options are documented and commented below.
  # For a complete reference, please see the online documentation at
  # https://docs.vagrantup.com.

  config.vm.hostname = "hft-exchange"
  config.vm.network "private_network", ip: "192.168.128.1"

  # Setting up virtualbox settings
  config.vm.provider "virtualbox" do |vb|
    vb.memory = "4096"
    vb.cpus = 4

    # Time sync every 10 seconds
    vb.customize [ "guestproperty", "set", :id, "/VirtualBox/GuestAdd/VBoxService/--timesync-set-threshold", 10000 ]
  end


  # Setting up the VMs
  # OME: 192.168.65.X
  #  GW: 192.168.64.X
  #  TP: 192.168.63.X
  config.vm.define "ome1" do |ome|
    ome.vm.box = "minimal/xenial64"
    ome.vm.boot_timeout = 1200
    ome.vm.hostname = "order-matching-engine"
    ome.vm.provision "shell", path: "scripts/init-ome.sh", privileged: false

    # Networking
    ome.vm.network "private_network", ip: "192.168.65.1"
  end

  config.vm.define "gateway1" do |gateway|
    gateway.vm.box = "minimal/xenial64"
    gateway.vm.boot_timeout = 1200
    gateway.vm.hostname = "gateway"
    gateway.vm.provision "shell", path: "scripts/init-gw.sh", privileged: false

    # Networking
    gateway.vm.network "private_network", ip: "192.168.64.1"
  end

  config.vm.define "tp1" do |tp|
    tp.vm.box = "minimal/xenial64"
    tp.vm.boot_timeout = 1200
    tp.vm.hostname = "tickerplant"
    tp.vm.provision "shell", path: "scripts/init-tp.sh", privileged: false

    # Networking
    tp.vm.network "private_network", ip: "192.168.63.1"
  end

end
